#include <windows.h>
#include "..\resource.h"
LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam);
HINSTANCE hInst;
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
{
	HWND hwnd;
	MSG  msg;
	WNDCLASS WndClass;   
	hInst = hInstance;

	WndClass.style = CS_HREDRAW | CS_VREDRAW;
	WndClass.lpfnWndProc = WndProc;		
	WndClass.cbClsExtra	= 0;		
	WndClass.cbWndExtra	= 0;		
	WndClass.hInstance = hInstance;		
	WndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	WndClass.hCursor = LoadCursor(NULL, IDC_ARROW);	
	WndClass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);	
	WndClass.lpszMenuName = MAKEINTRESOURCE(IDR_MENU8_4);		
	WndClass.lpszClassName= "Window Class Name";	
	RegisterClass(&WndClass);	
	hwnd = CreateWindow(
		"Window Class Name",
		"Main Window Title",
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT,	
		CW_USEDEFAULT,	
		CW_USEDEFAULT,	
		CW_USEDEFAULT,	
		NULL,	
		NULL,	
		hInstance,	
		NULL	 
	);
	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);	
		DispatchMessage(&msg);	
	}   
	return (int)msg.wParam;
}

void FileRead(HWND hwnd, char *filename)
{
	HANDLE hFile;
	char *buffer;
	DWORD size, CharNum;
	int fileSize;
	hFile=CreateFile(
		filename, 
		GENERIC_READ, 
		0, 
		0, 
		OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL,
		0
	);
	if (hFile == INVALID_HANDLE_VALUE) 
		return;
	fileSize = GetFileSize(hFile, &size);
	buffer = (char *)malloc(fileSize + 1); 
	memset(buffer, 0, fileSize + 1); 
	ReadFile(hFile, buffer, fileSize, &CharNum, NULL);
	SetWindowText(hwnd, buffer);
	CloseHandle(hFile);
}

void FileSave(HWND hwnd, char *filename)
{
	HANDLE hFile;
	char *buffer;
	int size;
	hFile = CreateFile(
		filename, 
		GENERIC_WRITE, 
		0, 
		0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
	);
	size = GetWindowTextLength(hwnd);
	buffer = (char *)malloc(size + 1);
	memset(buffer, 0, size + 1);
	size = GetWindowText(hwnd, (LPTSTR)buffer, size + 1);	
	WriteFile(hFile, buffer, size, (LPDWORD)&size, NULL);
	CloseHandle(hFile);
}

#define IDC_EDIT8_4 100
LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, 
						WPARAM wParam, LPARAM lParam)     
{
	static HWND hEdit;
	RECT rect;

	switch (iMsg) 
	{
	case WM_CREATE:
		GetClientRect(hwnd, &rect);
		hEdit = CreateWindow( 
			"edit", 
			NULL, 
			WS_CHILD | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL | 
			   ES_AUTOHSCROLL | ES_AUTOVSCROLL | ES_MULTILINE, 
			0, 
			100,
			rect.right,
			rect.bottom,
			hwnd, 
			(HMENU)IDC_EDIT8_4,
			hInst,
			NULL
		);
		return 0;
	case WM_SIZE:
		GetClientRect(hwnd, &rect);
		MoveWindow(hEdit, 0, 0, rect.right, rect.bottom, TRUE);
		return 0;
	case WM_COMMAND:
		switch(LOWORD(wParam))
		{
		case ID_FILEOPEN:
			FileRead(hEdit, "test2.txt");
			break;
		case ID_FILESAVE:
			FileSave(hEdit, "test2.txt");
			break;
		}
		return 0;
	case WM_DESTROY:
		PostQuitMessage(0);
		return 0;
	} 
  return DefWindowProc(hwnd, iMsg, wParam, lParam);
}